mbed TLS v2.14.1

Data Structures | Macros | Typedefs | Functions
camellia.h File Reference

Camellia block cipher. More...

`#include "config.h"`
`#include <stddef.h>`
`#include <stdint.h>`
Include dependency graph for camellia.h:

Go to the source code of this file.

## Data Structures
struct | mbedtls_camellia_context
| CAMELLIA context structure. More...

## Macros
#define | MBEDTLS_CAMELLIA_ENCRYPT 1
#define | MBEDTLS_CAMELLIA_DECRYPT 0
#define | MBEDTLS_ERR_CAMELLIA_INVALID_KEY_LENGTH -0x0024
#define | MBEDTLS_ERR_CAMELLIA_INVALID_INPUT_LENGTH -0x0026
#define | MBEDTLS_ERR_CAMELLIA_HW_ACCEL_FAILED -0x0027

## Typedefs
typedef struct mbedtls_camellia_context | mbedtls_camellia_context
| CAMELLIA context structure. More...

## Functions
void | mbedtls_camellia_init (mbedtls_camellia_context *ctx)
| Initialize CAMELLIA context. More...
void | mbedtls_camellia_free (mbedtls_camellia_context *ctx)
| Clear CAMELLIA context. More...
int | mbedtls_camellia_setkey_enc (mbedtls_camellia_context *ctx, const unsigned char *key, unsigned int keybits)
| CAMELLIA key schedule (encryption) More...
int | mbedtls_camellia_setkey_dec (mbedtls_camellia_context *ctx, const unsigned char *key, unsigned int keybits)
| CAMELLIA key schedule (decryption) More...
int | mbedtls_camellia_crypt_ecb (mbedtls_camellia_context *ctx, int mode, const unsigned char input[16], unsigned char output[16])
| CAMELLIA-ECB block encryption/decryption. More...
int | mbedtls_camellia_crypt_cbc (mbedtls_camellia_context *ctx, int mode, size_t length, unsigned char iv[16], const unsigned char *input, unsigned char *output)
| CAMELLIA-CBC buffer encryption/decryption Length should be a multiple of the block size (16 bytes) More...
int | mbedtls_camellia_crypt_cfb128 (mbedtls_camellia_context *ctx, int mode, size_t length, size_t *iv_off, unsigned char iv[16], const unsigned char *input, unsigned char *output)
| CAMELLIA-CFB128 buffer encryption/decryption. More...
int | mbedtls_camellia_crypt_ctr (mbedtls_camellia_context *ctx, size_t length, size_t *nc_off, unsigned char nonce_counter[16], unsigned char stream_block[16], const unsigned char *input, unsigned char *output)
| CAMELLIA-CTR buffer encryption/decryption. More...
int | mbedtls_camellia_self_test (int verbose)
| Checkup routine. More...

## Detailed Description

Camellia block cipher.

Definition in file camellia.h.

## Macro Definition Documentation

## ◆ MBEDTLS_CAMELLIA_DECRYPT

#define MBEDTLS_CAMELLIA_DECRYPT 0

Definition at line 37 of file camellia.h.

## ◆ MBEDTLS_CAMELLIA_ENCRYPT

#define MBEDTLS_CAMELLIA_ENCRYPT 1

Definition at line 36 of file camellia.h.

## ◆ MBEDTLS_ERR_CAMELLIA_HW_ACCEL_FAILED

#define MBEDTLS_ERR_CAMELLIA_HW_ACCEL_FAILED -0x0027

Camellia hardware accelerator failed.

Definition at line 44 of file camellia.h.

## ◆ MBEDTLS_ERR_CAMELLIA_INVALID_INPUT_LENGTH

#define MBEDTLS_ERR_CAMELLIA_INVALID_INPUT_LENGTH -0x0026

Invalid data input length.

Definition at line 40 of file camellia.h.

## ◆ MBEDTLS_ERR_CAMELLIA_INVALID_KEY_LENGTH

#define MBEDTLS_ERR_CAMELLIA_INVALID_KEY_LENGTH -0x0024

Invalid key length.

Definition at line 39 of file camellia.h.

## Typedef Documentation

## ◆ mbedtls_camellia_context

typedef struct mbedtls_camellia_context mbedtls_camellia_context

CAMELLIA context structure.

## Function Documentation

## ◆ mbedtls_camellia_crypt_cbc()

int mbedtls_camellia_crypt_cbc | ( | mbedtls_camellia_context * | ctx,
|  | int | mode,
|  | size_t | length,
|  | unsigned char | iv[16],
|  | const unsigned char * | input,
|  | unsigned char * | output
| ) |  |

CAMELLIA-CBC buffer encryption/decryption Length should be a multiple of the block size (16 bytes)

Note
  Upon exit, the content of the IV is updated so that you can call the function same function again on the following block(s) of data and get the same result as if it was encrypted in one call. This allows a "streaming" usage. If on the other hand you need to retain the contents of the IV, you should either save it manually or use the cipher module instead.

Parameters

  ctx | CAMELLIA context
  mode | MBEDTLS_CAMELLIA_ENCRYPT or MBEDTLS_CAMELLIA_DECRYPT
  length | length of the input data
  iv | initialization vector (updated after use)
  input | buffer holding the input data
  output | buffer holding the output data

Returns
  0 if successful, or MBEDTLS_ERR_CAMELLIA_INVALID_INPUT_LENGTH

## ◆ mbedtls_camellia_crypt_cfb128()

int mbedtls_camellia_crypt_cfb128 | ( | mbedtls_camellia_context * | ctx,
|  | int | mode,
|  | size_t | length,
|  | size_t * | iv_off,
|  | unsigned char | iv[16],
|  | const unsigned char * | input,
|  | unsigned char * | output
| ) |  |

CAMELLIA-CFB128 buffer encryption/decryption.

Note: Due to the nature of CFB you should use the same key schedule for both encryption and decryption. So a context initialized with mbedtls_camellia_setkey_enc() for both MBEDTLS_CAMELLIA_ENCRYPT and CAMELLIE_DECRYPT.

Note
  Upon exit, the content of the IV is updated so that you can call the function same function again on the following block(s) of data and get the same result as if it was encrypted in one call. This allows a "streaming" usage. If on the other hand you need to retain the contents of the IV, you should either save it manually or use the cipher module instead.

Parameters

  ctx | CAMELLIA context
  mode | MBEDTLS_CAMELLIA_ENCRYPT or MBEDTLS_CAMELLIA_DECRYPT
  length | length of the input data
  iv_off | offset in IV (updated after use)
  iv | initialization vector (updated after use)
  input | buffer holding the input data
  output | buffer holding the output data

Returns
  0 if successful, or MBEDTLS_ERR_CAMELLIA_INVALID_INPUT_LENGTH

## ◆ mbedtls_camellia_crypt_ctr()

int mbedtls_camellia_crypt_ctr | ( | mbedtls_camellia_context * | ctx,
|  | size_t | length,
|  | size_t * | nc_off,
|  | unsigned char | nonce_counter[16],
|  | unsigned char | stream_block[16],
|  | const unsigned char * | input,
|  | unsigned char * | output
| ) |  |

CAMELLIA-CTR buffer encryption/decryption.

Note: Due to the nature of CTR you should use the same key schedule for both encryption and decryption. So a context initialized with mbedtls_camellia_setkey_enc() for both MBEDTLS_CAMELLIA_ENCRYPT and MBEDTLS_CAMELLIA_DECRYPT.

Warning
  You must never reuse a nonce value with the same key. Doing so would void the encryption for the two messages encrypted with the same nonce and key.

There are two common strategies for managing nonces with CTR:

1. You can handle everything as a single message processed over successive calls to this function. In that case, you want to set `nonce_counter` and `nc_off` to 0 for the first call, and then preserve the values of `nonce_counter`, `nc_off` and `stream_block` across calls to this function as they will be updated by this function.

With this strategy, you must not encrypt more than 2**128 blocks of data with the same key.

1. You can encrypt separate messages by dividing the `nonce_counter` buffer in two areas: the first one used for a per-message nonce, handled by yourself, and the second one updated by this function internally.

For example, you might reserve the first 12 bytes for the per-message nonce, and the last 4 bytes for internal use. In that case, before calling this function on a new message you need to set the first 12 bytes of `nonce_counter` to your chosen nonce value, the last 4 to 0, and `nc_off` to 0 (which will cause `stream_block` to be ignored). That way, you can encrypt at most 2**96 messages of up to 2**32 blocks each with the same key.

The per-message nonce (or information sufficient to reconstruct it) needs to be communicated with the ciphertext and must be unique. The recommended way to ensure uniqueness is to use a message counter. An alternative is to generate random nonces, but this limits the number of messages that can be securely encrypted: for example, with 96-bit random nonces, you should not encrypt more than 2**32 messages with the same key.

Note that for both stategies, sizes are measured in blocks and that a CAMELLIA block is 16 bytes.

Warning
  Upon return, `stream_block` contains sensitive data. Its content must not be written to insecure storage and should be securely discarded as soon as it's no longer needed.

Parameters

  ctx | CAMELLIA context
  length | The length of the data
  nc_off | The offset in the current stream_block (for resuming within current cipher stream). The offset pointer to should be 0 at the start of a stream.
  nonce_counter | The 128-bit nonce and counter.
  stream_block | The saved stream-block for resuming. Is overwritten by the function.
  input | The input data stream
  output | The output data stream

Returns
  0 if successful

## ◆ mbedtls_camellia_crypt_ecb()

int mbedtls_camellia_crypt_ecb | ( | mbedtls_camellia_context * | ctx,
|  | int | mode,
|  | const unsigned char | input[16],
|  | unsigned char | output[16]
| ) |  |

CAMELLIA-ECB block encryption/decryption.

Parameters

  ctx | CAMELLIA context
  mode | MBEDTLS_CAMELLIA_ENCRYPT or MBEDTLS_CAMELLIA_DECRYPT
  input | 16-byte input block
  output | 16-byte output block

Returns
  0 if successful

## ◆ mbedtls_camellia_free()

void mbedtls_camellia_free | ( | mbedtls_camellia_context * | ctx | ) |

Clear CAMELLIA context.

Parameters

  ctx | CAMELLIA context to be cleared

## ◆ mbedtls_camellia_init()

void mbedtls_camellia_init | ( | mbedtls_camellia_context * | ctx | ) |

Initialize CAMELLIA context.

Parameters

  ctx | CAMELLIA context to be initialized

## ◆ mbedtls_camellia_self_test()

int mbedtls_camellia_self_test | ( | int | verbose | ) |

Checkup routine.

Returns
  0 if successful, or 1 if the test failed

## ◆ mbedtls_camellia_setkey_dec()

int mbedtls_camellia_setkey_dec | ( | mbedtls_camellia_context * | ctx,
|  | const unsigned char * | key,
|  | unsigned int | keybits
| ) |  |

CAMELLIA key schedule (decryption)

Parameters

  ctx | CAMELLIA context to be initialized
  key | decryption key
  keybits | must be 128, 192 or 256

Returns
  0 if successful, or MBEDTLS_ERR_CAMELLIA_INVALID_KEY_LENGTH

## ◆ mbedtls_camellia_setkey_enc()

int mbedtls_camellia_setkey_enc | ( | mbedtls_camellia_context * | ctx,
|  | const unsigned char * | key,
|  | unsigned int | keybits
| ) |  |

CAMELLIA key schedule (encryption)

Parameters

  ctx | CAMELLIA context to be initialized
  key | encryption key
  keybits | must be 128, 192 or 256

Returns
  0 if successful, or MBEDTLS_ERR_CAMELLIA_INVALID_KEY_LENGTH